-- +migrate Up
DROP TABLE application_vulnerability;
CREATE TABLE  IF NOT EXISTS application_vulnerability (
  id BIGSERIAL PRIMARY KEY,
  application_id BIGINT,
  title VARCHAR(100),
  description TEXT,
  cve VARCHAR(100),
  link TEXT,
  component VARCHAR(200),
  version VARCHAR(50),
  origin TEXT,
  severity VARCHAR(25),
  fix_in VARCHAR(100),
  ignored BOOL
);
SELECT create_foreign_key_idx_cascade('FK_APPLICATION_VULN_APPLICATION', 'application_vulnerability', 'application', 'application_id', 'id');

CREATE TABLE  IF NOT EXISTS workflow_node_run_vulnerability (
  id BIGSERIAL PRIMARY KEY,
  application_id BIGINT,
  workflow_id BIGINT,
  workflow_run_id BIGINT,
  workflow_node_run_id BIGINT,
  workflow_number BIGINT,
  branch VARCHAR(100),
  report TEXT
);
SELECT create_foreign_key_idx_cascade('FK_WORKFLOW_NODE_RUN_VULN_APPLICATION', 'workflow_node_run_vulnerability', 'application', 'application_id', 'id');
SELECT create_foreign_key_idx_cascade('FK_WORKFLOW_NODE_RUN_VULN_RUN', 'workflow_node_run_vulnerability', 'workflow_run', 'workflow_run_id', 'id');
SELECT create_index('workflow_node_run_vulnerability','WORKFLOW_NODE_RUN_VULN_IDX', 'application_id,workflow_id,branch,workflow_number');

-- +migrate Down
DROP TABLE application_vulnerability;
